码迷,mamicode.com
首页 > 其他好文 > 详细

HDU 3415 Max Sum of Max-K-sub-sequence

时间:2014-06-22 22:07:25      阅读:188      评论:0      收藏:0      [点我收藏+]

标签:stl

转载请注明出处:http://blog.csdn.net/u012860063

Max Sum of Max-K-sub-sequence

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 5791    Accepted Submission(s): 2083


Problem Description
Given a circle sequence A[1],A[2],A[3]......A[n]. Circle sequence means the left neighbour of A[1] is A[n] , and the right neighbour of A[n] is A[1].
Now your job is to calculate the max sum of a Max-K-sub-sequence. Max-K-sub-sequence means a continuous non-empty sub-sequence which length not exceed K.
 

Input
The first line of the input contains an integer T(1<=T<=100) which means the number of test cases.
Then T lines follow, each line starts with two integers N , K(1<=N<=100000 , 1<=K<=N), then N integers followed(all the integers are between -1000 and 1000).
 

Output
For each test case, you should output a line contains three integers, the Max Sum in the sequence, the start position of the sub-sequence, the end position of the sub-sequence. If there are more than one result, output the minimum start position, if still more than one , output the minimum length of them.
 

Sample Input
4 6 3 6 -1 2 -6 5 -5 6 4 6 -1 2 -6 5 -5 6 3 -1 2 -6 5 -5 6 6 6 -1 -1 -1 -1 -1 -1
 

Sample Output
7 1 3 7 1 3 7 6 2 -1 1 1


附上别人的思路:

单调队列即保持队列中的元素单调递增(或递减)的这样一个队列,可以从两头删除,只能从队尾插入。单调队列的具体作用在于,由于保持队列中的元素满足单调性,对于上述问题中的每个j,可以用O(1)的时间找到对应的s[i]。(保持队列中的元素单调增的话,队首元素便是所要的元素了)。

维护方法:对于每个j,我们插入s[j-1](为什么不是s[j]? 队列里面维护的是区间开始的下标,j是区间结束的下标),插入时从队尾插入。为了保证队列的单调性,我们从队尾开始删除元素,直到队尾元素比当前需要插入的元素优(本题中是值比待插入元素小,位置比待插入元素靠前,不过后面这一个条件可以不考虑),就将当前元素插入到队尾。之所以可以将之前的队列尾部元素全部删除,是因为它们已经不可能成为最优的元素了,因为当前要插入的元素位置比它们靠前,值比它们小。我们要找的,是满足(i>=j-k+1)的i中最小的s[i],位置越大越可能成为后面的j的最优s[i]。

在插入元素后,从队首开始,将不符合限制条件(i>=j-k+1)的元素全部删除,此时队列一定不为空。(因为刚刚插入了一个一定符合条件的元素)

代码如下:(看了别人的才做出来的,汗)

#include <cstdio>
#include <cstring>
#include <queue>
#include <algorithm>
#include <iostream>
using namespace std;
#define INF 0x3fffffff
int sum[100047],a[200047];
int main()
{
	int t,i,n,m,k,head,end;
	scanf("%d",&t);
	while(t--)
	{
		memset(sum,0,sizeof(sum));
		scanf("%d%d",&n,&k);
		for(i = 1 ; i <= n ; i++)
		{
			scanf("%d",&a[i]);
			sum[i] = sum[i-1]+a[i];//将前i项和全部存入sum数组中
		}
		for(i = n+1 ; i < n+k ; i++)
		{
			sum[i] = sum[i-1]+a[i-n];//将前n+k-1项和全部存入sum数组中
		}
		int ans = -INF;//初始化ans为最小
		deque<int>Q;
		Q.clear();//清空双向队列
		for(i = 1 ; i < n+k ; i++)
		{
			while(!Q.empty() && sum[i-1] < sum[Q.back()])//保持队列的单调性(递增)
				Q.pop_back();
			while(!Q.empty() && i-k > Q.front())//超过k的长度则消除队列前面的元素
				Q.pop_front();
			Q.push_back(i-1);
			if(ans < sum[i]-sum[Q.front()])//如果当前的值比ans大就更新ans的值
			{                              //记录,sum[n]-sum[m]所得出的是n-1到m+1之间的和
				ans = sum[i]-sum[Q.front()];
				head = Q.front()+1;
				end = i;
			}
		}
		if(end > n)//标记的点大于了n则循环
			end%=n;
		if(head > n)//标记的点大于了n则循环
			head%=n;
		printf("%d %d %d\n",ans,head,end);
	}
	return 0;
}



HDU 3415 Max Sum of Max-K-sub-sequence,布布扣,bubuko.com

HDU 3415 Max Sum of Max-K-sub-sequence

标签:stl

原文地址:http://blog.csdn.net/u012860063/article/details/32713377

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!